/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// HighlightMetric the model 'HighlightMetric'
type HighlightMetric string

// List of HighlightMetric
const (
	MAIN_GOAL HighlightMetric = "main_goal"
	INVESTMENTS HighlightMetric = "investments"
	CHATS_STARTED HighlightMetric = "chats_started"
	CONSENTS HighlightMetric = "consents"
	INTERACTIONS HighlightMetric = "interactions"
	UNIQUE_CONTACTS HighlightMetric = "unique_contacts"
)

// All allowed values of HighlightMetric enum
var AllowedHighlightMetricEnumValues = []HighlightMetric{
	"main_goal",
	"investments",
	"chats_started",
	"consents",
	"interactions",
	"unique_contacts",
}

func (v *HighlightMetric) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := HighlightMetric(value)
	for _, existing := range AllowedHighlightMetricEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid HighlightMetric", value)
}

// NewHighlightMetricFromValue returns a pointer to a valid HighlightMetric
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewHighlightMetricFromValue(v string) (*HighlightMetric, error) {
	ev := HighlightMetric(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for HighlightMetric: valid values are %v", v, AllowedHighlightMetricEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v HighlightMetric) IsValid() bool {
	for _, existing := range AllowedHighlightMetricEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to HighlightMetric value
func (v HighlightMetric) Ptr() *HighlightMetric {
	return &v
}

type NullableHighlightMetric struct {
	value *HighlightMetric
	isSet bool
}

func (v NullableHighlightMetric) Get() *HighlightMetric {
	return v.value
}

func (v *NullableHighlightMetric) Set(val *HighlightMetric) {
	v.value = val
	v.isSet = true
}

func (v NullableHighlightMetric) IsSet() bool {
	return v.isSet
}

func (v *NullableHighlightMetric) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHighlightMetric(val *HighlightMetric) *NullableHighlightMetric {
	return &NullableHighlightMetric{value: val, isSet: true}
}

func (v NullableHighlightMetric) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHighlightMetric) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

